annotate top/maint.mk @ 9811:5f79eb63c21e

Alter GNUmakefile to install into top directory. * modules/maintainer-makefile: Split, and add dependency... * modules/gnumakefile: to this new module. * build-aux/GNUmakefile: Move... * top/GNUmakefile: ...here. * build-aux/maint.mk: Move... * top/maint.mk: ...here. * MODULES.html.sh (Support for maintaining...): Document new module. Signed-off-by: Eric Blake <ebb9@byu.net>
author Eric Blake <ebb9@byu.net>
date Fri, 21 Mar 2008 22:29:37 -0600
parents
children 60ed1a52905e
Ignore whitespace changes - Everywhere: Within whitespace: At end of lines:
rev   line source
9811
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
1 # -*-Makefile-*-
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
2 # This Makefile fragment is intended to be useful by any GNU-like project.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
3 # This file originate from coreutils, CPPI, Bison, and Autoconf.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
4
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
5 # Copyright (C) 2001-2007 Free Software Foundation, Inc.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
6 #
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
7 # This program is free software; you can redistribute it and/or modify
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
8 # it under the terms of the GNU General Public License as published by
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
9 # the Free Software Foundation; either version 3 of the License,
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
10 # or (at your option) any later version.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
11 #
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
12 # This program is distributed in the hope that it will be useful,
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
15 # GNU General Public License for more details.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
16 #
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
17 # You should have received a copy of the GNU General Public License
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
18 # along with this program. If not, see <http://www.gnu.org/licenses/>.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
19
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
20 ME := maint.mk
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
21
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
22 # List of all C-like source code files that will be tested for
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
23 # stylistic "errors". You may want to define this to something
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
24 # more complex in Makefile.cfg.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
25 C_SOURCES ?= $(shell find . -name '*.[chly]')
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
26
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
27 # Add some more files to check, typically set in Makefile.cfg.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
28 C_SOURCES += $(C_SOURCES_ADD)
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
29
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
30 # Do not save the original name or timestamp in the .tar.gz file.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
31 # Use --rsyncable if available.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
32 gzip_rsyncable := \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
33 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null && echo --rsyncable)
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
34 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
35
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
36 # Prevent programs like 'sort' from considering distinct strings to be equal.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
37 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
38 export LC_ALL = C
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
39
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
40 # Casting arguments to free is never necessary.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
41 sc_cast_of_argument_to_free:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
42 @grep -nE '\<free *\( *\(' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
43 { echo '$(ME): don'\''t cast free argument' 1>&2; \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
44 exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
45
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
46 sc_cast_of_x_alloc_return_value:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
47 @grep -nE '\*\) *x(m|c|re)alloc\>' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
48 { echo '$(ME): don'\''t cast x*alloc return value' 1>&2; \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
49 exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
50
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
51 sc_cast_of_alloca_return_value:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
52 @grep -nE '\*\) *alloca\>' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
53 { echo '$(ME): don'\''t cast alloca return value' 1>&2; \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
54 exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
55
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
56 sc_space_tab:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
57 @grep -n '[ ] ' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
58 { echo '$(ME): found SPACE-TAB sequence; remove the SPACE' \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
59 1>&2; exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
60
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
61 # Don't use the old ato* functions in `real' code.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
62 # They provide no error checking mechanism.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
63 # Instead, use strto* functions.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
64 sc_prohibit_atoi_atof:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
65 @grep -nE '\<ato([filq]|ll)\>' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
66 { echo '$(ME): do not use ato''f, ato''i, ato''l, ato''ll, or ato''q' \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
67 1>&2; exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
68
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
69 # Using EXIT_SUCCESS as the first argument to error is misleading,
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
70 # since when that parameter is 0, error does not exit. Use `0' instead.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
71 sc_error_exit_success:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
72 @grep -nF 'error (EXIT_SUCCESS,' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
73 { echo '$(ME): found error (EXIT_SUCCESS' 1>&2; \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
74 exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
75
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
76 # Stylistic, use #ifdef instead of #if
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
77 sc_no_if_have_config_h:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
78 @grep -n '^# *if HAVE_CONFIG_H' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
79 { echo '$(ME): found use of #if HAVE_CONFIG_H; use #ifdef' \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
80 1>&2; exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
81
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
82 # Prohibit the inclusion of assert.h without an actual use of assert.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
83 sc_prohibit_assert_without_use:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
84 @files=$$(grep -l '# *include [<"]assert\.h[>"]' $(C_SOURCES) \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
85 | grep '\.[cy]$$') && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
86 grep -L '\<assert (' $$files \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
87 | grep . && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
88 { echo "$(ME): the above files include <assert.h> but don't use it" \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
89 1>&2; exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
90
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
91 sc_obsolete_symbols:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
92 @grep -nE '\<(HAVE''_FCNTL_H|O''_NDELAY)\>' $(C_SOURCES) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
93 { echo '$(ME): do not use HAVE''_FCNTL_H or O''_NDELAY' \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
94 1>&2; exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
95
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
96 # Each nonempty line must start with a year number, or a TAB.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
97 sc_changelog:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
98 @grep -n '^[^12 ]' $$(find . -name ChangeLog) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
99 { echo '$(ME): found unexpected prefix in a ChangeLog' 1>&2; \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
100 exit 1; } || :
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
101
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
102 # Collect the names of rules starting with `sc_'.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
103 syntax-check-rules := $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' $(ME))
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
104 .PHONY: $(syntax-check-rules)
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
105
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
106 syntax-check: $(syntax-check-rules)
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
107
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
108 # Update gettext files.
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
109 PACKAGE ?= $(shell basename $(PWD))
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
110 POURL = http://translationproject.org/latest/$(PACKAGE)/
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
111 PODIR ?= po
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
112 refresh-po:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
113 rm -f $(PODIR)/*.po && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
114 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
115 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
116 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
117 echo 'en@quot' >> $(PODIR)/LINGUAS && \
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
118 ls $(PODIR)/*.po | sed 's/.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
119
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
120 INDENT_SOURCES ?= $(C_SOURCES)
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
121 .PHONY: indent
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
122 indent:
5f79eb63c21e Alter GNUmakefile to install into top directory.
Eric Blake <ebb9@byu.net>
parents:
diff changeset
123 indent $(INDENT_SOURCES)